#ifndef MY_HISTOGRAM
#define MY_HISTOGRAM


#include "i3d/image3d.h"

/**
 * Computes histogram from the whole input image \e img.
 */
void ComputeHistogram(const i3d::Image3d<i3d::GRAY8>& img,
								int (&histogram)[256]);

/**
 * Computes histogram only inside the given region \e voi
 * in the input image \e img. The function works only within
 * the intersection of the given \e voi and the image \e img.
 */
void ComputeHistogram(const i3d::Image3d<i3d::GRAY8>& img,
								const i3d::VOI<i3d::PIXELS> &voi,
								int (&histogram)[256]);

#endif
