#ifndef MY_MYLIST
#define MY_MYLIST


/**
 * element of the list,
 * the list shall represent a histogram
 */
struct Elem {
	int intensity;
	int count;
	struct Elem* next;
	struct Elem* prev;
};

/**
 * Adds value \e val to the histogram/list \e *h .
 *
 * And returns how many comparisons there had to
 * be evaluated during the addition.
 */
int AddToHistogram(struct Elem** h,
							const int val);

/**
 * Adds value \e val to the histogram/list \e *h 
 * utilizing the fact that the last added value 
 * was added to the element \e *p . Afterwards,
 * the \e *p points to the added/updated element.
 *
 * And returns how many comparisons there had to
 * be evaluated during the addition.
 */
int AddToHistogram(struct Elem** h,
							struct Elem** p,
							const int val);

#endif
