#include "i3d/image3d.h"
#include "rgbgray.h"

using namespace i3d;


void RGBtoGRAY8(const Image3d<RGB>& in,Image3d<GRAY8>& out)
{
	//nachysta vystupni obraz tak, aby mel stejna metadata 
	//(tj. rozliseni, velikost, atd.) a alokuje pamet,
	//takze vystupni obraz je nachystany pro praci
	out.CopyMetaData(in);

	//pointery pro prochazeni obrazu
	const RGB *rgb=in.GetFirstVoxelAddr();
	GRAY8 *g=out.GetFirstVoxelAddr();

	for (size_t i=0; i < in.GetImageSize(); ++i)
	{
		float tmp=0.2126f * (float)rgb->red
			+ 0.7152f * (float)rgb->green
			+ 0.0722f * (float)rgb->blue;
		*g=(GRAY8)tmp;

		++g; ++rgb;
	}
}

