#ifndef MY_THRESHOLD
#define MY_THRESHOLD


#include "i3d/image3d.h"

/**
This function thresholds given img \e img according to the threshold \e thres.
The modification changes value of every pixel either to values 0 or 1.
*/
void Threshold(i3d::Image3d<i3d::GRAY8> &img,const i3d::GRAY8 thres);

/**
 * This function thresholds given img \e img only inside the region \e voi
 * according to the threshold \e thres. The function works only within
 * the intersection of the given \e voi and the image \e img.
 *
 * The modification changes value of every pixel either to values 0 or 1.
 */
void Threshold(i3d::Image3d<i3d::GRAY8> &img,
					const i3d::VOI<i3d::PIXELS> &voi,
					const i3d::GRAY8 thres);

/**
 * Suggests optimal threshold value based on histogram analysis.
 * Note, no input image is given, just the histogram.
 */
int SuggestThreshold(const int (&histogram)[256]);

#endif
